upstream bisad-api-prod {
  server bisad-api-prod:8000;
}

server {
  ##
  # Genaral Setting
  ##
  listen 80;
  listen [::]:80;
  server_name api.bisad.vasin.me;

  
  # Redirect
  # return 301 https://api.bisad.vasin.me$request_uri;
}

server {
  # Genaral Setting
  listen 443 ssl;
  listen [::]:443 ssl;
  server_name api.bisad.vasin.me;

  ##
  # Auto Https
  ##
  if ($http_x_forwarded_proto = "http") {
   return 301 https://api.bisad.vasin.me$request_uri;
  }

  ##
  # SSL Setting
  ##
  ssl on;
  ssl_certificate /etc/nginx/ssl/vasin.crt;
  ssl_certificate_key /etc/nginx/ssl/vasin.key;
  # ssl_certificate /etc/nginx/ssl/ssl.chained.crt;
  # ssl_certificate_key /etc/nginx/ssl/ssl.key;
  ssl_protocols TLSv1 TLSv1.1 TLSv1.2;
  ssl_prefer_server_ciphers on;
  ssl_ciphers AES256+EECDH:AES256+EDH:!aNULL;

  location / {
    proxy_set_header Upgrade $http_upgrade;
    proxy_set_header Connection "upgrade";
    proxy_set_header X-Forwarded-Proto https;
    proxy_set_header X-Forwarded-Proto https;
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header Host $http_host;
    proxy_redirect off;
    proxy_pass http://bisad-api-prod;

    # add Strict-Transport-Security to prevent man in the middle attacks
    add_header Strict-Transport-Security "max-age=31536000" always;
  }
}


